<?php

namespace Treewec\Utils;

/**
 * Test class for Arrays.
 * Generated by PHPUnit on 2012-03-25 at 16:22:02.
 * @group utils
 */
class ArraysTest extends \PHPUnit_Framework_TestCase {
    
    private $array;

    protected function setUp() {        
        $this->array = array('Hello', 'World', '!!!');
    }

    public function testConvertArrayToString() {
        parent::assertEquals(Arrays::convertArrayToString($this->array), 'Hello/World/!!!');
        parent::assertEquals(Arrays::convertArrayToString($this->array, ' '), 'Hello World !!!');
        
        $this->assertIsEmptyString(Arrays::convertArrayToString(new \Exception()));
        $this->assertIsEmptyString(Arrays::convertArrayToString($this->array, null));        
    }

    public function testConvertStringToArray() {
        parent::assertEquals(Arrays::convertStringToArray('Hello/World/!!!'), $this->array);
        parent::assertEquals(Arrays::convertStringToArray('Hello*World*!!!', '*'), $this->array);
        
        $this->assertIsEmptyArray(Arrays::convertStringToArray(new \Exception()));
        $this->assertIsEmptyArray(Arrays::convertStringToArray($this->array, null));  
    }

    public function testConvertArrayToStringPairs() {
        parent::assertEquals(Arrays::convertArrayToStringPairs($this->array), array('0=Hello', '1=World', '2=!!!'));
        parent::assertEquals(Arrays::convertArrayToStringPairs($this->array, '>'), array('0>Hello', '1>World', '2>!!!'));
        
        $this->assertIsEmptyArray(Arrays::convertArrayToStringPairs(new \Exception()));
        $this->assertIsEmptyArray(Arrays::convertArrayToStringPairs($this->array, null));  
    }

    public function testIsArrayWithScalarValues() {
        parent::assertTrue(Arrays::isArrayWithScalarValues($this->array));
        parent::assertFalse(Arrays::isArrayWithScalarValues(null));
        parent::assertFalse(Arrays::isArrayWithScalarValues(array(null)));        
        parent::assertFalse(Arrays::isArrayWithScalarValues(array(array())));
        parent::assertFalse(Arrays::isArrayWithScalarValues(array(new \Exception())));
    }

    public function testGetNumberOfEmptyValues() {
        parent::assertEquals(Arrays::getNumberOfEmptyValues(array(null, false, array())), 3);        
        parent::assertEquals(Arrays::getNumberOfEmptyValues($this->array), 0);
        parent::assertEquals(Arrays::getNumberOfEmptyValues(null), 0);
    }

    private function assertIsEmptyString($string) {
        parent::assertTrue($string == '');
    }
    
    private function assertIsEmptyArray($array) {
        parent::assertTrue($array == array());
    }
}

?>
